<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);

//Start the PHP session
session_start();

//Get the access token from the session
$accessToken = $_SESSION['accessToken'];

//Get the order id from the session
$orderId = $_SESSION['orderId'];

//Initiate CURL and set the url endpoint including the order id for the order
$ch = curl_init();
$url = "https://api.sandbox.paypal.com/v2/checkout/orders/$orderId/capture";
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_ECS/cert/cacert.pem');

$BNCode = 'MyBnCode';
$merchantId = '4SBV8P49XCTL8';
$jwtHeader = base64_encode('{"alg":"none"}');
$jwtBody = base64_encode("{'iss':'AcNEYyp4KIYuTLS9KOsZr9Ua0Gi2c4p5dOSfSnoYTL9ZgdpNyNEvTE6LaF60Xy89BkMGFFMw4HxSb5Tf','payer_id':'$merchantId'}");
$jwtSig = base64_encode("");
$ppAssertion = $jwtHeader.'.'.$jwtBody.$jwtSig.'.';

//Set the required headers
$headers = array(
    'Accept: application/json',
    "PayPal-Partner-Attribution-Id: $BNCode",
    'Content-Type: application/json',
    "Authorization: Bearer $accessToken",
    "PayPal-Auth-Assertion: $ppAssertion",
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Lets curl know we are using 'post' and not 'get' (false = 'get')
curl_setopt($ch, CURLOPT_POST, TRUE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

$id = $_SESSION['billingAgreementId'];
$type = "BILLING_AGREEMENT";

$token['id'] = $id;
$token['type'] = $type;

$payment_source['token'] = $token;

$vars['payment_source'] = $payment_source;

//Build and set the request
$json ='';
$json = json_encode($vars);
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);

//echo $json;

//Get the response back
$response = curl_exec($ch);

//parse json into object
$outArray = json_decode($response, true);

//Print the response
echo "<pre>";
print_r($outArray);
echo "</pre>";






